http: always warn if libcurl version is too old
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
f6a52799 11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
893a9764 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
82f49f29 15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
8f321a39 16OPTIONS_SPEC=
091a6eb0 17SUBDIRECTORY_OK=Yes
70c7ac22 18. git-sh-setup
d0ad8251 19. git-sh-i18n
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
33cfccbb
JK
25# Restrict ourselves to a vanilla subset of protocols; the URLs
26# we get are under control of a remote repository, and we do not
27# want them kicking off arbitrary git-remote-* programs.
28#
29# If the user has already specified a set of allowed protocols,
30# we assume they know what they're doing and use that instead.
31: ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
32export GIT_ALLOW_PROTOCOL
33
5c08dbbd 34command=
ecda0723 35branch=
d27b876b 36force=
d92a3959 37reference=
70c7ac22 38cached=
48bb3033
GP
39recursive=
40init=
1c244f6e 41files=
06b1abb5 42remote=
31ca3ac3 43nofetch=
32948425 44update=
15fc56a8 45prefix=
73b0898d 46custom_name=
275cd184 47depth=
70c7ac22 48
be9d0a3a
HV
49die_if_unmatched ()
50{
51 if test "$1" = "#unmatched"
52 then
53 exit 1
54 fi
55}
56
88ce00c3
TK
57#
58# Print a submodule configuration setting
59#
60# $1 = submodule name
61# $2 = option name
62# $3 = default value
63#
64# Checks in the usual git-config places first (for overrides),
65# otherwise it falls back on .gitmodules. This allows you to
66# distribute project-wide defaults in .gitmodules, while still
67# customizing individual repositories if necessary. If the option is
68# not in .gitmodules either, print a default value.
69#
70get_submodule_config () {
71 name="$1"
72 option="$2"
73 default="$3"
74 value=$(git config submodule."$name"."$option")
75 if test -z "$value"
76 then
77 value=$(git config -f .gitmodules submodule."$name"."$option")
78 fi
79 printf '%s' "${value:-$default}"
80}
81
862ae6cd
RS
82isnumber()
83{
84 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
85}
86
14111fc4
JK
87# Sanitize the local git environment for use within a submodule. We
88# can't simply use clear_local_git_env since we want to preserve some
89# of the settings from GIT_CONFIG_PARAMETERS.
90sanitize_submodule_env()
91{
89044baa 92 save_config=$GIT_CONFIG_PARAMETERS
14111fc4 93 clear_local_git_env
89044baa 94 GIT_CONFIG_PARAMETERS=$save_config
860cba61 95 export GIT_CONFIG_PARAMETERS
14111fc4
JK
96}
97
ecda0723
SV
98#
99# Add a new submodule to the working tree, .gitmodules and the index
100#
ec05df35 101# $@ = repo path
ecda0723
SV
102#
103# optional branch is stored in global branch variable
104#
23a485e3 105cmd_add()
ecda0723 106{
5c08dbbd 107 # parse $args after "submodule ... add".
091a6eb0 108 reference_path=
5c08dbbd
JH
109 while test $# -ne 0
110 do
111 case "$1" in
112 -b | --branch)
113 case "$2" in '') usage ;; esac
114 branch=$2
115 shift
116 ;;
d27b876b
JL
117 -f | --force)
118 force=$1
119 ;;
5c08dbbd 120 -q|--quiet)
2e6a30ef 121 GIT_QUIET=1
5c08dbbd 122 ;;
d92a3959
MT
123 --reference)
124 case "$2" in '') usage ;; esac
091a6eb0 125 reference_path=$2
d92a3959
MT
126 shift
127 ;;
128 --reference=*)
091a6eb0 129 reference_path="${1#--reference=}"
d92a3959 130 ;;
73b0898d
JL
131 --name)
132 case "$2" in '') usage ;; esac
133 custom_name=$2
134 shift
135 ;;
275cd184
FG
136 --depth)
137 case "$2" in '') usage ;; esac
138 depth="--depth=$2"
139 shift
140 ;;
141 --depth=*)
142 depth=$1
143 ;;
5c08dbbd
JH
144 --)
145 shift
146 break
147 ;;
148 -*)
149 usage
150 ;;
151 *)
152 break
153 ;;
154 esac
155 shift
156 done
157
091a6eb0
JK
158 if test -n "$reference_path"
159 then
160 is_absolute_path "$reference_path" ||
161 reference_path="$wt_prefix$reference_path"
162
163 reference="--reference=$reference_path"
164 fi
165
ecda0723 166 repo=$1
64394e3a 167 sm_path=$2
ecda0723 168
64394e3a 169 if test -z "$sm_path"; then
6a066230 170 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
171 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
172 fi
173
496eeeb1 174 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
175 usage
176 fi
177
091a6eb0
JK
178 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
179
ec05df35
ML
180 # assure repo is absolute or relative to parent
181 case "$repo" in
182 ./*|../*)
091a6eb0
JK
183 test -z "$wt_prefix" ||
184 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
185
ec05df35 186 # dereference source url relative to parent's url
63e95beb 187 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
ec05df35
ML
188 ;;
189 *:*|/*)
190 # absolute url
191 realrepo=$repo
192 ;;
193 *)
497ee872 194 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
195 ;;
196 esac
197
db75ada5
MG
198 # normalize path:
199 # multiple //; leading ./; /./; /../; trailing /
64394e3a 200 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
201 sed -e '
202 s|//*|/|g
203 s|^\(\./\)*||
8196e728 204 s|/\(\./\)*|/|g
db75ada5
MG
205 :start
206 s|\([^/]*\)/\.\./||
207 tstart
208 s|/*$||
209 ')
64394e3a
RJ
210 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
211 die "$(eval_gettext "'\$sm_path' already exists in the index")"
ecda0723 212
64394e3a 213 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
d27b876b 214 then
6ff875c5 215 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 216\$sm_path
6ff875c5 217Use -f if you really want to add it." >&2
d27b876b
JL
218 exit 1
219 fi
220
73b0898d
JL
221 if test -n "$custom_name"
222 then
223 sm_name="$custom_name"
224 else
225 sm_name="$sm_path"
226 fi
227
d4264ca3 228 # perhaps the path exists and is already a git repo, else clone it
64394e3a 229 if test -e "$sm_path"
d4264ca3 230 then
496eeeb1 231 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 232 then
64394e3a 233 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 234 else
64394e3a 235 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 236 fi
c2f93917 237
d4264ca3 238 else
4b7c286e
JL
239 if test -d ".git/modules/$sm_name"
240 then
241 if test -z "$force"
242 then
243 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
244 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
245 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
246 echo >&2 " $realrepo"
247 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
248 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
249 else
250 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
251 fi
252 fi
d10e3b42 253 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
d851ffb9 254 (
14111fc4 255 sanitize_submodule_env
d851ffb9
JH
256 cd "$sm_path" &&
257 # ash fails to wordsplit ${branch:+-b "$branch"...}
258 case "$branch" in
259 '') git checkout -f -q ;;
260 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
261 esac
262 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 263 fi
73b0898d 264 git config submodule."$sm_name".url "$realrepo"
d4264ca3 265
64394e3a
RJ
266 git add $force "$sm_path" ||
267 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 268
73b0898d
JL
269 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
270 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
271 if test -n "$branch"
272 then
273 git config -f .gitmodules submodule."$sm_name".branch "$branch"
274 fi &&
31991b02 275 git add --force .gitmodules ||
64394e3a 276 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
ecda0723
SV
277}
278
19a31f9c
ML
279#
280# Execute an arbitrary command sequence in each checked out
281# submodule
282#
283# $@ = command to execute
284#
285cmd_foreach()
286{
1d5bec8b
JH
287 # parse $args after "submodule ... foreach".
288 while test $# -ne 0
289 do
290 case "$1" in
291 -q|--quiet)
292 GIT_QUIET=1
293 ;;
15fc56a8
JH
294 --recursive)
295 recursive=1
296 ;;
1d5bec8b
JH
297 -*)
298 usage
299 ;;
300 *)
301 break
302 ;;
303 esac
304 shift
305 done
306
f030c96d
ÆAB
307 toplevel=$(pwd)
308
4dca1aa6
BC
309 # dup stdin so that it can be restored when running the external
310 # command in the subshell (and a recursive call to this function)
311 exec 3<&0
312
b0f4b408
SB
313 {
314 git submodule--helper list --prefix "$wt_prefix" ||
315 echo "#unmatched"
316 } |
64394e3a 317 while read mode sha1 stage sm_path
19a31f9c 318 do
be9d0a3a 319 die_if_unmatched "$mode"
64394e3a 320 if test -e "$sm_path"/.git
19a31f9c 321 then
44431df0 322 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
ea2fa104 323 say "$(eval_gettext "Entering '\$displaypath'")"
0ea306ef 324 name=$(git submodule--helper name "$sm_path")
15fc56a8 325 (
64394e3a 326 prefix="$prefix$sm_path/"
14111fc4 327 sanitize_submodule_env
64394e3a 328 cd "$sm_path" &&
44431df0 329 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
091a6eb0
JK
330 # we make $path available to scripts ...
331 path=$sm_path &&
1c4fb136
AK
332 if test $# -eq 1
333 then
334 eval "$1"
335 else
336 "$@"
337 fi &&
15fc56a8
JH
338 if test -n "$recursive"
339 then
340 cmd_foreach "--recursive" "$@"
341 fi
4dca1aa6 342 ) <&3 3<&- ||
ea2fa104 343 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
19a31f9c
ML
344 fi
345 done
346}
347
70c7ac22 348#
211b7f19 349# Register submodules in .git/config
70c7ac22
LH
350#
351# $@ = requested paths (default to all)
352#
23a485e3 353cmd_init()
70c7ac22 354{
5c08dbbd
JH
355 # parse $args after "submodule ... init".
356 while test $# -ne 0
357 do
358 case "$1" in
359 -q|--quiet)
2e6a30ef 360 GIT_QUIET=1
5c08dbbd
JH
361 ;;
362 --)
363 shift
364 break
365 ;;
366 -*)
367 usage
368 ;;
369 *)
370 break
371 ;;
372 esac
373 shift
374 done
375
3604242f 376 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper init ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} "$@"
70c7ac22
LH
377}
378
cf419828
JL
379#
380# Unregister submodules from .git/config and remove their work tree
381#
cf419828
JL
382cmd_deinit()
383{
384 # parse $args after "submodule ... deinit".
f6a52799 385 deinit_all=
cf419828
JL
386 while test $# -ne 0
387 do
388 case "$1" in
389 -f|--force)
390 force=$1
391 ;;
392 -q|--quiet)
393 GIT_QUIET=1
394 ;;
f6a52799
SB
395 --all)
396 deinit_all=t
397 ;;
cf419828
JL
398 --)
399 shift
400 break
401 ;;
402 -*)
403 usage
404 ;;
405 *)
406 break
407 ;;
408 esac
409 shift
410 done
411
f6a52799
SB
412 if test -n "$deinit_all" && test "$#" -ne 0
413 then
414 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
415 usage
416 fi
417 if test $# = 0 && test -z "$deinit_all"
cf419828 418 then
f6a52799 419 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
cf419828
JL
420 fi
421
b0f4b408
SB
422 {
423 git submodule--helper list --prefix "$wt_prefix" "$@" ||
424 echo "#unmatched"
425 } |
cf419828
JL
426 while read mode sha1 stage sm_path
427 do
428 die_if_unmatched "$mode"
0ea306ef 429 name=$(git submodule--helper name "$sm_path") || exit
cf419828 430
44431df0 431 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
091a6eb0 432
cf419828
JL
433 # Remove the submodule work tree (unless the user already did it)
434 if test -d "$sm_path"
435 then
436 # Protect submodules containing a .git directory
437 if test -d "$sm_path/.git"
438 then
091a6eb0 439 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
cf419828
JL
440 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
441 fi
442
443 if test -z "$force"
444 then
7b294bf4 445 git rm -qn "$sm_path" ||
091a6eb0 446 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
cf419828 447 fi
7b294bf4 448 rm -rf "$sm_path" &&
091a6eb0
JK
449 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
450 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
cf419828
JL
451 fi
452
091a6eb0 453 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
cf419828
JL
454
455 # Remove the .git/config entries (unless the user already did it)
456 if test -n "$(git config --get-regexp submodule."$name\.")"
457 then
458 # Remove the whole section so we have a clean state when
459 # the user later decides to init this submodule again
460 url=$(git config submodule."$name".url)
461 git config --remove-section submodule."$name" 2>/dev/null &&
091a6eb0 462 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
cf419828
JL
463 fi
464 done
465}
466
fb43e31f 467is_tip_reachable () (
01e1d544 468 sanitize_submodule_env &&
fb43e31f
SB
469 cd "$1" &&
470 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
471 test -z "$rev"
472)
473
474fetch_in_submodule () (
01e1d544 475 sanitize_submodule_env &&
fb43e31f
SB
476 cd "$1" &&
477 case "$2" in
478 '')
479 git fetch ;;
480 *)
481 git fetch $(get_default_remote) "$2" ;;
482 esac
483)
484
70c7ac22 485#
211b7f19 486# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
487#
488# $@ = requested paths (default to all)
489#
23a485e3 490cmd_update()
70c7ac22 491{
5c08dbbd
JH
492 # parse $args after "submodule ... update".
493 while test $# -ne 0
494 do
495 case "$1" in
496 -q|--quiet)
2e6a30ef 497 GIT_QUIET=1
5c08dbbd 498 ;;
be4d2c83 499 -i|--init)
d92a3959 500 init=1
be4d2c83 501 ;;
06b1abb5
TK
502 --remote)
503 remote=1
504 ;;
31ca3ac3 505 -N|--no-fetch)
31ca3ac3
FF
506 nofetch=1
507 ;;
9db31bdf
NMC
508 -f|--force)
509 force=$1
510 ;;
ca2cedba 511 -r|--rebase)
32948425 512 update="rebase"
ca2cedba 513 ;;
d92a3959
MT
514 --reference)
515 case "$2" in '') usage ;; esac
516 reference="--reference=$2"
98dbe63d 517 shift
d92a3959
MT
518 ;;
519 --reference=*)
520 reference="$1"
d92a3959 521 ;;
42b49178 522 -m|--merge)
42b49178
JH
523 update="merge"
524 ;;
b13fd5c1 525 --recursive)
b13fd5c1
JH
526 recursive=1
527 ;;
efc5fb6a
JH
528 --checkout)
529 update="checkout"
530 ;;
275cd184
FG
531 --depth)
532 case "$2" in '') usage ;; esac
533 depth="--depth=$2"
534 shift
535 ;;
536 --depth=*)
537 depth=$1
538 ;;
2335b870
SB
539 -j|--jobs)
540 case "$2" in '') usage ;; esac
541 jobs="--jobs=$2"
542 shift
543 ;;
544 --jobs=*)
545 jobs=$1
546 ;;
5c08dbbd
JH
547 --)
548 shift
549 break
550 ;;
551 -*)
552 usage
553 ;;
554 *)
555 break
556 ;;
557 esac
98dbe63d 558 shift
5c08dbbd
JH
559 done
560
d92a3959
MT
561 if test -n "$init"
562 then
563 cmd_init "--" "$@" || return
564 fi
565
48308681
SB
566 {
567 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
568 ${wt_prefix:+--prefix "$wt_prefix"} \
569 ${prefix:+--recursive-prefix "$prefix"} \
570 ${update:+--update "$update"} \
571 ${reference:+--reference "$reference"} \
572 ${depth:+--depth "$depth"} \
2335b870 573 ${jobs:+$jobs} \
48308681
SB
574 "$@" || echo "#unmatched"
575 } | {
15ffb7cd 576 err=
48308681 577 while read mode sha1 stage just_cloned sm_path
70c7ac22 578 do
be9d0a3a 579 die_if_unmatched "$mode"
48308681 580
0ea306ef 581 name=$(git submodule--helper name "$sm_path") || exit
5be60078 582 url=$(git config submodule."$name".url)
d851ffb9 583 branch=$(get_submodule_config "$name" branch master)
efc5fb6a
JH
584 if ! test -z "$update"
585 then
586 update_module=$update
587 else
588 update_module=$(git config submodule."$name".update)
a2aed08b
TK
589 if test -z "$update_module"
590 then
591 update_module="checkout"
592 fi
efc5fb6a
JH
593 fi
594
44431df0 595 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
091a6eb0 596
48308681 597 if test $just_cloned -eq 1
d851ffb9 598 then
bf2d8246 599 subsha1=
48308681 600 update_module=checkout
bf2d8246 601 else
14111fc4 602 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 603 git rev-parse --verify HEAD) ||
091a6eb0 604 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 605 fi
211b7f19 606
06b1abb5
TK
607 if test -n "$remote"
608 then
609 if test -z "$nofetch"
610 then
611 # Fetch remote before determining tracking $sha1
14111fc4 612 (sanitize_submodule_env; cd "$sm_path" && git-fetch) ||
06b1abb5
TK
613 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
614 fi
14111fc4
JK
615 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
616 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5
TK
617 git rev-parse --verify "${remote_name}/${branch}") ||
618 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
619 fi
620
496eeeb1 621 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 622 then
9db31bdf
NMC
623 subforce=$force
624 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 625 if test -z "$subsha1" && test -z "$force"
b9b378a0 626 then
9db31bdf 627 subforce="-f"
b9b378a0 628 fi
31ca3ac3
FF
629
630 if test -z "$nofetch"
631 then
e5f522d6
JL
632 # Run fetch only if $sha1 isn't present or it
633 # is not reachable from a ref.
fb43e31f
SB
634 is_tip_reachable "$sm_path" "$sha1" ||
635 fetch_in_submodule "$sm_path" ||
091a6eb0 636 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
fb43e31f
SB
637
638 # Now we tried the usual fetch, but $sha1 may
639 # not be reachable from any of the refs
640 is_tip_reachable "$sm_path" "$sha1" ||
641 fetch_in_submodule "$sm_path" "$sha1" ||
642 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain $sha1. Direct fetching of that commit failed.")"
31ca3ac3
FF
643 fi
644
877449c1 645 must_die_on_failure=
32948425 646 case "$update_module" in
a2aed08b
TK
647 checkout)
648 command="git checkout $subforce -q"
649 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
650 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
651 ;;
32948425
JH
652 rebase)
653 command="git rebase"
091a6eb0
JK
654 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
655 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 656 must_die_on_failure=yes
32948425 657 ;;
42b49178
JH
658 merge)
659 command="git merge"
091a6eb0
JK
660 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
661 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 662 must_die_on_failure=yes
42b49178 663 ;;
6cb5728c
CP
664 !*)
665 command="${update_module#!}"
b08238ac
SB
666 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
667 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
6cb5728c
CP
668 must_die_on_failure=yes
669 ;;
32948425 670 *)
a2aed08b 671 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
32948425 672 esac
70c7ac22 673
14111fc4 674 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 675 then
ff968f03 676 say "$say_msg"
877449c1
JH
677 elif test -n "$must_die_on_failure"
678 then
ff968f03 679 die_with_status 2 "$die_msg"
15ffb7cd 680 else
ff968f03 681 err="${err};$die_msg"
877449c1 682 continue
15ffb7cd 683 fi
70c7ac22 684 fi
b13fd5c1
JH
685
686 if test -n "$recursive"
687 then
75bf5e60 688 (
44431df0 689 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
3604242f 690 wt_prefix=
14111fc4 691 sanitize_submodule_env
75bf5e60 692 cd "$sm_path" &&
36141282 693 eval cmd_update
75bf5e60 694 )
15ffb7cd
FG
695 res=$?
696 if test $res -gt 0
697 then
091a6eb0 698 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
15ffb7cd
FG
699 if test $res -eq 1
700 then
ff968f03 701 err="${err};$die_msg"
15ffb7cd
FG
702 continue
703 else
ff968f03 704 die_with_status $res "$die_msg"
15ffb7cd
FG
705 fi
706 fi
b13fd5c1 707 fi
70c7ac22 708 done
15ffb7cd
FG
709
710 if test -n "$err"
711 then
712 OIFS=$IFS
713 IFS=';'
714 for e in $err
715 do
716 if test -n "$e"
717 then
718 echo >&2 "$e"
719 fi
720 done
721 IFS=$OIFS
722 exit 1
723 fi
724 }
70c7ac22
LH
725}
726
bffe71f4
EM
727set_name_rev () {
728 revname=$( (
14111fc4 729 sanitize_submodule_env
bffe71f4 730 cd "$1" && {
5be60078
JH
731 git describe "$2" 2>/dev/null ||
732 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
733 git describe --contains "$2" 2>/dev/null ||
734 git describe --all --always "$2"
bffe71f4
EM
735 }
736 ) )
737 test -z "$revname" || revname=" ($revname)"
738}
28f9af5d
PY
739#
740# Show commit summary for submodules in index or working tree
741#
742# If '--cached' is given, show summary between index and given commit,
743# or between working tree and given commit
744#
745# $@ = [commit (default 'HEAD'),] requested paths (default all)
746#
747cmd_summary() {
f2dc06a3 748 summary_limit=-1
d0f64dd4 749 for_status=
1c244f6e 750 diff_cmd=diff-index
f2dc06a3 751
28f9af5d
PY
752 # parse $args after "submodule ... summary".
753 while test $# -ne 0
754 do
755 case "$1" in
756 --cached)
757 cached="$1"
758 ;;
1c244f6e
JL
759 --files)
760 files="$1"
761 ;;
d0f64dd4
PY
762 --for-status)
763 for_status="$1"
764 ;;
f2dc06a3 765 -n|--summary-limit)
862ae6cd
RS
766 summary_limit="$2"
767 isnumber "$summary_limit" || usage
f2dc06a3
PY
768 shift
769 ;;
862ae6cd
RS
770 --summary-limit=*)
771 summary_limit="${1#--summary-limit=}"
772 isnumber "$summary_limit" || usage
773 ;;
28f9af5d
PY
774 --)
775 shift
776 break
777 ;;
778 -*)
779 usage
780 ;;
781 *)
782 break
783 ;;
784 esac
785 shift
786 done
bffe71f4 787
f2dc06a3
PY
788 test $summary_limit = 0 && return
789
3deea89c 790 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
791 then
792 head=$rev
caa9c3ca 793 test $# = 0 || shift
496eeeb1 794 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 795 then
14e940d7
JH
796 # before the first commit: compare with an empty tree
797 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 798 test -z "$1" || shift
28f9af5d 799 else
3deea89c 800 head="HEAD"
28f9af5d
PY
801 fi
802
1c244f6e
JL
803 if [ -n "$files" ]
804 then
805 test -n "$cached" &&
465d6a00 806 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
807 diff_cmd=diff-files
808 head=
809 fi
810
28f9af5d 811 cd_to_toplevel
091a6eb0 812 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 813 # Get modified modules cared by user
18076502 814 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 815 sane_egrep '^:([0-7]* )?160000' |
2be94509 816 while read mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
817 do
818 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
819 if test "$status" = D || test "$status" = T
820 then
6a066230 821 printf '%s\n' "$sm_path"
496eeeb1
EP
822 continue
823 fi
927b26f8 824 # Respect the ignore setting for --for-status.
825 if test -n "$for_status"
826 then
0ea306ef 827 name=$(git submodule--helper name "$sm_path")
927b26f8 828 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 829 test $status != A && test $ignore_config = all && continue
927b26f8 830 fi
28f9af5d 831 # Also show added or modified modules which are checked out
2be94509 832 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 833 printf '%s\n' "$sm_path"
28f9af5d
PY
834 done
835 )
1cb639e6 836
d0f64dd4
PY
837 test -z "$modules" && return
838
18076502 839 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 840 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
841 cut -c2- |
842 while read mod_src mod_dst sha1_src sha1_dst status name
843 do
844 if test -z "$cached" &&
845 test $sha1_dst = 0000000000000000000000000000000000000000
846 then
847 case "$mod_dst" in
848 160000)
849 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
850 ;;
851 100644 | 100755 | 120000)
852 sha1_dst=$(git hash-object $name)
853 ;;
854 000000)
855 ;; # removed
856 *)
857 # unexpected type
6ff875c5 858 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
859 continue ;;
860 esac
861 fi
862 missing_src=
863 missing_dst=
864
865 test $mod_src = 160000 &&
30353a40 866 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
867 missing_src=t
868
869 test $mod_dst = 160000 &&
30353a40 870 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 871 missing_dst=t
bffe71f4 872
44431df0 873 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
091a6eb0 874
1cb639e6
PY
875 total_commits=
876 case "$missing_src,$missing_dst" in
877 t,)
091a6eb0 878 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
879 ;;
880 ,t)
091a6eb0 881 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
882 ;;
883 t,t)
091a6eb0 884 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
885 ;;
886 *)
887 errmsg=
888 total_commits=$(
496eeeb1 889 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
890 then
891 range="$sha1_src...$sha1_dst"
892 elif test $mod_src = 160000
893 then
894 range=$sha1_src
895 else
896 range=$sha1_dst
897 fi
898 GIT_DIR="$name/.git" \
b0e621ad 899 git rev-list --first-parent $range -- | wc -l
1cb639e6 900 )
eed35595 901 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
902 ;;
903 esac
904
905 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
906 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
907 if test $status = T
908 then
b3e73449
ÆAB
909 blob="$(gettext "blob")"
910 submodule="$(gettext "submodule")"
1cb639e6
PY
911 if test $mod_dst = 160000
912 then
091a6eb0 913 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 914 else
091a6eb0 915 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
916 fi
917 else
091a6eb0 918 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
919 fi
920 if test -n "$errmsg"
921 then
922 # Don't give error msg for modification whose dst is not submodule
923 # i.e. deleted or changed to blob
924 test $mod_dst = 160000 && echo "$errmsg"
925 else
496eeeb1 926 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 927 then
f2dc06a3
PY
928 limit=
929 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 930 GIT_DIR="$name/.git" \
f2dc06a3 931 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
932 --first-parent $sha1_src...$sha1_dst
933 elif test $mod_dst = 160000
934 then
935 GIT_DIR="$name/.git" \
936 git log --pretty='format: > %s' -1 $sha1_dst
937 else
938 GIT_DIR="$name/.git" \
939 git log --pretty='format: < %s' -1 $sha1_src
940 fi
941 echo
942 fi
943 echo
3ba7407b 944 done
28f9af5d 945}
70c7ac22 946#
941987a5 947# List all submodules, prefixed with:
70c7ac22
LH
948# - submodule not initialized
949# + different revision checked out
950#
951# If --cached was specified the revision in the index will be printed
952# instead of the currently checked out revision.
953#
954# $@ = requested paths (default to all)
955#
23a485e3 956cmd_status()
70c7ac22 957{
5c08dbbd
JH
958 # parse $args after "submodule ... status".
959 while test $# -ne 0
960 do
961 case "$1" in
962 -q|--quiet)
2e6a30ef 963 GIT_QUIET=1
5c08dbbd
JH
964 ;;
965 --cached)
966 cached=1
967 ;;
64b19ffe
JH
968 --recursive)
969 recursive=1
970 ;;
5c08dbbd
JH
971 --)
972 shift
973 break
974 ;;
975 -*)
976 usage
977 ;;
978 *)
979 break
980 ;;
981 esac
982 shift
983 done
984
b0f4b408
SB
985 {
986 git submodule--helper list --prefix "$wt_prefix" "$@" ||
987 echo "#unmatched"
988 } |
64394e3a 989 while read mode sha1 stage sm_path
70c7ac22 990 do
be9d0a3a 991 die_if_unmatched "$mode"
0ea306ef 992 name=$(git submodule--helper name "$sm_path") || exit
5be60078 993 url=$(git config submodule."$name".url)
44431df0 994 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
313ee0d6
NMC
995 if test "$stage" = U
996 then
997 say "U$sha1 $displaypath"
998 continue
999 fi
496eeeb1
EP
1000 if test -z "$url" ||
1001 {
1002 ! test -d "$sm_path"/.git &&
1003 ! test -f "$sm_path"/.git
1004 }
70c7ac22 1005 then
64b19ffe 1006 say "-$sha1 $displaypath"
70c7ac22
LH
1007 continue;
1008 fi
64394e3a 1009 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
70c7ac22 1010 then
b545cd15 1011 set_name_rev "$sm_path" "$sha1"
64b19ffe 1012 say " $sha1 $displaypath$revname"
70c7ac22
LH
1013 else
1014 if test -z "$cached"
1015 then
14111fc4 1016 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
70c7ac22 1017 fi
b545cd15 1018 set_name_rev "$sm_path" "$sha1"
64b19ffe
JH
1019 say "+$sha1 $displaypath$revname"
1020 fi
1021
1022 if test -n "$recursive"
1023 then
1024 (
1025 prefix="$displaypath/"
14111fc4 1026 sanitize_submodule_env
10450cf7 1027 wt_prefix=
64394e3a 1028 cd "$sm_path" &&
e15bec0e 1029 eval cmd_status
64b19ffe 1030 ) ||
64394e3a 1031 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
70c7ac22
LH
1032 fi
1033 done
1034}
2327f61e
DA
1035#
1036# Sync remote urls for submodules
1037# This makes the value for remote.$remote.url match the value
1038# specified in .gitmodules.
1039#
1040cmd_sync()
1041{
1042 while test $# -ne 0
1043 do
1044 case "$1" in
1045 -q|--quiet)
2e6a30ef 1046 GIT_QUIET=1
2327f61e
DA
1047 shift
1048 ;;
82f49f29
PH
1049 --recursive)
1050 recursive=1
1051 shift
1052 ;;
2327f61e
DA
1053 --)
1054 shift
1055 break
1056 ;;
1057 -*)
1058 usage
1059 ;;
1060 *)
1061 break
1062 ;;
1063 esac
1064 done
1065 cd_to_toplevel
b0f4b408
SB
1066 {
1067 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1068 echo "#unmatched"
1069 } |
64394e3a 1070 while read mode sha1 stage sm_path
2327f61e 1071 do
be9d0a3a 1072 die_if_unmatched "$mode"
0ea306ef 1073 name=$(git submodule--helper name "$sm_path")
2327f61e 1074 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
1075
1076 # Possibly a url relative to parent
1077 case "$url" in
1078 ./*|../*)
967b2c66
JS
1079 # rewrite foo/bar as ../.. to find path from
1080 # submodule work tree to superproject work tree
6a066230 1081 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
967b2c66
JS
1082 # guarantee a trailing /
1083 up_path=${up_path%/}/ &&
1084 # path from submodule work tree to submodule origin repo
63e95beb 1085 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
967b2c66 1086 # path from superproject work tree to submodule origin repo
63e95beb 1087 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
967b2c66
JS
1088 ;;
1089 *)
1090 sub_origin_url="$url"
1091 super_config_url="$url"
baede9f8
JH
1092 ;;
1093 esac
1094
ccee6086 1095 if git config "submodule.$name.url" >/dev/null 2>/dev/null
2327f61e 1096 then
44431df0 1097 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
091a6eb0 1098 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
967b2c66 1099 git config submodule."$name".url "$super_config_url"
ccee6086 1100
64394e3a 1101 if test -e "$sm_path"/.git
ccee6086
JH
1102 then
1103 (
14111fc4 1104 sanitize_submodule_env
64394e3a 1105 cd "$sm_path"
ccee6086 1106 remote=$(get_default_remote)
967b2c66 1107 git config remote."$remote".url "$sub_origin_url"
82f49f29
PH
1108
1109 if test -n "$recursive"
1110 then
1111 prefix="$prefix$sm_path/"
1112 eval cmd_sync
1113 fi
ccee6086
JH
1114 )
1115 fi
2327f61e
DA
1116 fi
1117 done
1118}
70c7ac22 1119
5c08dbbd
JH
1120# This loop parses the command line arguments to find the
1121# subcommand name to dispatch. Parsing of the subcommand specific
1122# options are primarily done by the subcommand implementations.
1123# Subcommand specific options such as --branch and --cached are
1124# parsed here as well, for backward compatibility.
1125
1126while test $# != 0 && test -z "$command"
70c7ac22
LH
1127do
1128 case "$1" in
cf419828 1129 add | foreach | init | deinit | update | status | summary | sync)
5c08dbbd 1130 command=$1
70c7ac22
LH
1131 ;;
1132 -q|--quiet)
2e6a30ef 1133 GIT_QUIET=1
70c7ac22 1134 ;;
ecda0723
SV
1135 -b|--branch)
1136 case "$2" in
1137 '')
1138 usage
1139 ;;
1140 esac
1141 branch="$2"; shift
1142 ;;
70c7ac22 1143 --cached)
28f9af5d 1144 cached="$1"
70c7ac22
LH
1145 ;;
1146 --)
1147 break
1148 ;;
1149 -*)
1150 usage
1151 ;;
1152 *)
1153 break
1154 ;;
1155 esac
1156 shift
1157done
1158
5c08dbbd 1159# No command word defaults to "status"
af9c9f97
RR
1160if test -z "$command"
1161then
1162 if test $# = 0
1163 then
1164 command=status
1165 else
1166 usage
1167 fi
1168fi
5c08dbbd
JH
1169
1170# "-b branch" is accepted only by "add"
1171if test -n "$branch" && test "$command" != add
1172then
ecda0723 1173 usage
5c08dbbd
JH
1174fi
1175
28f9af5d 1176# "--cached" is accepted only by "status" and "summary"
496eeeb1 1177if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1178then
70c7ac22 1179 usage
5c08dbbd
JH
1180fi
1181
1182"cmd_$command" "$@"